function Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller(General, ScreenService, localStorageEngine, ZhFilterPreferences, Utilities, MessageService) {
    this.widgetOnEnter = function(widget) {
        const filialField = widget.getField("CDFILIAL");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            var filterRow = {
        	    INTERVALO_DATA : {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILIAL: [ getLocalVar("CDFILIAL") ],
        	    NMFILIAL: [ getLocalVar("NMFILIAL") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILIAL = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.cmp03200_filial_movopsol.forEach(function(filial) {
                        if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete filterRow.CDFILIAL;
                        delete filterRow.NMFILIAL;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp03200_filial_movopsol.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_MOVOPSOL", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILIAL;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
            
            if (widget.OPENED) {
                delete widget.OPENED;
                
                widget.getAction('back_alt_automatica').isVisible = true;
                
                widget.dataSourceFilter = [];
                widget.dataSource.reload().then(function() {
                    widget._filterInfo = [];
                    widget.container.getWidget('stripe').getField('UNIDADE').label = ScreenService.i18n('Unidade Solicitante: ');
                    widget.container.getWidget('stripe').getField('PERIODO').label = ScreenService.i18n('Período: ');
                });
            } else {
                widget.getAction('back_alt_automatica').isVisible = false;
            }
            
            Utilities.startFilter(widget, filterRow);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };
    
    this.setFilterInitValues = function(widget){
        var filterRow = {
            'NMFILIAL': getLocalVar('NMFILIAL'),
            'INTERVALO_DATA': {
                'start': moment().format('L'),
                'end': moment().format('L')
            }
        };
        
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
        return defaultValue;
    }
    
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        const filterPopupCurrentRow = args.row;
        
        if (!(this.validaProduto(filterPopupCurrentRow.CDARVPRODINI, filterPopupCurrentRow.CDARVPRODFIN))){
            if (field.name == 'NMPRODINI') {
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.CDARVPRODINI = '';
                filterPopupCurrentRow.NMPRODINI = '';
            } else {
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.CDARVPRODFIN = '';
                filterPopupCurrentRow.NMPRODFIN = '';
            }
        }
    };
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", "ERROR");
                return false;
            }
        }

        return true;
    }; 
    this.readOnlyProduto = function(widget) {
        if (!widget.getField('NMPRODINI').value() && !widget.getField('NMPRODFIN').value()) {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        }
        else {
            widget.getField('NMPRODINI').validations = {
                "required": true
            };
            widget.getField('NMPRODFIN').validations = {
                "required": true
            };
        }
    };
    
    this.setStripe = function(widget, filterRow){
     
    	var filial = filterRow.NMFILIAL == "@getLocalVar('NMFILIAL')@" ? getLocalVar('NMFILIAL') : filterRow.NMFILIAL;
    	widget.container.getWidget('stripe').getField('UNIDADE').label = ScreenService.i18n('Unidade Solicitante: ') + filial;
        widget.container.getWidget('stripe').getField('PERIODO').label = ScreenService.i18n('Período: ') + filterRow.INTERVALO_DATA.start + ' à '  + filterRow.INTERVALO_DATA.end;
    
        widget._filterInfo = [
            {"label": ScreenService.i18n("Unidade "), "value": filterRow.CDFILIAL.join(',')},    
            {"label": ScreenService.i18n("Dt. Entrega"), "value": filterRow.INTERVALO_DATA.start + ' à '  + filterRow.INTERVALO_DATA.end},         
            {"label": ScreenService.i18n("Produto Inicial"), "value": filterRow.NMPRODINI ? filterRow.NMPRODINI : ScreenService.i18n("Todos")},             
            {"label": ScreenService.i18n("Produto Final"), "value": filterRow.NMPRODFIN  ? filterRow.NMPRODFIN : ScreenService.i18n("Todos")}               
        ];
    };
    
    /**
     * Define o CUSTOM_FILTER_ROW vazio para evitar que o filtro do Zeedhi
     * seja aplicado com os valores do FILTER_ROW
     */
    this.trataFiltroBeforeApply = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = [];
    };
    
    this.filtrar = function(args) {
        var widget = args.owner,
            filterRow = args.e.preference.FILTER_ROW;

        // if (widget.isValid() && this.validaProduto(row.CDPRODINI,row.CDPRODFIN, widget)) {

            //this.setStripe(widget, filterRow);
         

            filterRow.CDPRODINI = filterRow.CDPRODFIN ? filterRow.CDARVPRODINI : null;
            filterRow.CDPRODFIN = filterRow.CDPRODFIN ? preencheCaracterDireta(filterRow.CDARVPRODFIN) : null;

            widget.dataSourceFilter = [
                {
                    "name": "CDFILSOLMOV",
                    "operator": "=",
                    "value": concatArrayForParams(filterRow.CDFILIAL)
                },
                {
                    "name": "PRODINI",
                    "operator": "=",
                    "value": filterRow.CDPRODINI
                },
                {
                    "name": "PRODFIN",
                    "operator": "=",
                    "value": filterRow.CDPRODFIN
                },
                {
                    "name": "DENTRINI",
                    "operator": "=",
                    "value": filterRow.INTERVALO_DATA.start
                },
                {
                    "name": "DENTRFIN",
                    "operator": "=",
                    "value": filterRow.INTERVALO_DATA.end
                },
                {
                    "name": "SOLEXC",
                    "operator": "=",
                    "value": filterRow.SOLEXC
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                },
                {
                    "name": "P_TCDPRODUTO",
                    "operator": "=",
                    "value": (filterRow.CDPRODINI && filterRow.CDPRODFIN) ? null : 'T' 
                },
                {
                    "name": "P_CDOPERADOR",
                    "operator": "=",
                    "value": getLocalVar("CDOPERADOR")
                }
            ];
            ScreenService.closePopup();
            widget.activate();
            widget.reload();
        
    };

    function preencheCaracterDireta(string) {
        return string.padEnd(20,'Z');
    }
    
    this.voltarParaAlteracaoAutomatica = function() {
        ScreenService.goBack();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller', Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller);
});
