var defaultFilterRow = {};

module.exports = {
    'getDefaultFilterRow' : defaultFilterRow,
    'applyFilterLabel': "Aplicar filtro"
}
var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
var z = new ZeedhiAPIConstructor(browser, protractor);

var loginPage = require('./page objects/login.po.js');
var menuPage = require('./page objects/menu.po.js');
var util = require('../util/util.js');
var base = require('./page objects/pageObject.po.js');
var decache = require('decache');

var calculoNecessidadeCompras = require('./page objects/calculoNecessidadeCompras.po');
var planejamentoProducao = require('./page objects/planejamentoProducao.po');

describe('Teste Cálculo da Necessidade de Compras', function () {
    browser.get(browser.params.applicationUrl);
    browser.driver.manage().window().maximize();

    it('Deve realizar login', function () {
        z.application.waitZhLoading();
        loginPage.login('bruno', '1');
        util.waitForAngular();
        expect(browser.getCurrentUrl()).toContain('/dsb/#/dsb#dashboard');
    });

    it('Deve acessar a tela Aprovação de Preparação do Orçamento pelo menu', function () {
        calculoNecessidadeCompras.abrir('Cálculo da Necessidade de Compras', 'Cálculo da Necessidade de Compras');
        expect(browser.getCurrentUrl()).toContain('/cmp/#/cmp_necessidadeCompras#calculo_da_necessidade_de_compras');
    });

    it('Deve limpar os campos e tentar realizar o cálculo', function () {
        calculoNecessidadeCompras.limpaCampos();
        Promise.all([
            expect(element(by.css('body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section:nth-child(1) > div > div:nth-child(2) > div > div > div.zh-validation > span')).isPresent()).toBeTruthy(),
            expect(element(by.css('body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section:nth-child(2) > div > div:nth-child(1) > div > div > div.zh-validation > span')).isPresent()).toBeTruthy(),
            expect(element(by.css('body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section:nth-child(3) > div > div > div:nth-child(1) > div > div.zh-validation > span')).isPresent()).toBeTruthy(),
            expect(element(by.css('body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section:nth-child(3) > div > div > div.col-xs-6.zh-field.last-of-row > div > div.zh-validation > span')).isPresent()).toBeTruthy()]);
    });

  
    it('Deve preencher os campos obrigatórios e ralizar o cáluclo', function () {
        browser.get('http://tecfoodteste.teknisa.com//cmp/#/cmp_necessidadeCompras#calculo_da_necessidade_de_compras');
        calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        calculoNecessidadeCompras.selecionaPeriodo(/*'30/08/2019', '30/08/2019'*/);
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');
        calculoNecessidadeCompras.calcula();
        expect(calculoNecessidadeCompras.textoStripe()).toBe('Necessidade de Compras');      
    });

    it('Deve gerar a necessidade de compras', function () {
        calculoNecessidadeCompras.geraNecessidade();
        expect(calculoNecessidadeCompras.textoAlert()).toContain('Solicitação de compras gerada com sucesso');  
    });

    it('Deve preencher o campo ‘Produto Final’ menor que o campo ‘Produto inicial', function () {
    browser.get('http://tecfoodteste.teknisa.com//cmp/#/cmp_necessidadeCompras#calculo_da_necessidade_de_compras');
    browser.sleep(2000);
    calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
    //calculoNecessidadeCompras.selecionaPeriodo();
    calculoNecessidadeCompras.selecionaProduto('CRESOTO EMBALAGEM DE 1 KG', 'MATERIA PRIMA');
    z.component.footer.clickCenterActionByLabel('Calcular');
    expect(calculoNecessidadeCompras.textoAlert()).toContain('Produto inicial deve ser menor ou igual a produto final.');  
    browser.sleep(2000);
    z.component.alert.clickButton('OK');

    });
    
    it('Deve habilitar o campo Acréscimo(%) na tela de Parâmentros de Compras e Suprimentos', function () {
        calculoNecessidadeCompras.abrir('Parâmetros de Compras e Suprimentos', 'Parâmetros de Compras e Suprimentos');
        calculoNecessidadeCompras.navegar('Unidade');
        calculoNecessidadeCompras.parametroUnidadeDiversos('DEPOSITO BC 129');
        calculoNecessidadeCompras.parametroAcrescimo();
		z.component.footer.clickRightActionByLabel('Salvar');
        calculoNecessidadeCompras.abrir('Cálculo da Necessidade de Compras', 'Cálculo da Necessidade de Compras');
        calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        //calculoNecessidadeCompras.selecionaPeriodo();
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');
        expect(element(by.css('#PEACRESCIMO')).getAttribute('disabled')).toBe(null);
    });

    it('Deve inserir um valor muito grande no campo Acréscimo (%)', function () {
        /*calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        //calculoNecessidadeCompras.selecionaPeriodo();
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');*/
        calculoNecessidadeCompras.acrescimo('1000000');
        z.component.footer.clickCenterActionByLabel('Calcular');
        expect(calculoNecessidadeCompras.textoAlert()).toContain('Acréscimo deve ser menor que 10000%');
        z.component.alert.clickButton('OK');
    });

    it('Deve desabilitar o campo Acréscimo(%) na tela de Parâmentros de Compras e Suprimentos', function () {
        calculoNecessidadeCompras.abrir('Parâmetros de Compras e Suprimentos', 'Parâmetros de Compras e Suprimentos');
        calculoNecessidadeCompras.navegar('Unidade');
        calculoNecessidadeCompras.parametroUnidadeDiversos('DEPOSITO BC 129');
        calculoNecessidadeCompras.parametroAcrescimoDesabilitado();
		z.component.footer.clickRightActionByLabel('Salvar');
        calculoNecessidadeCompras.abrir('Cálculo da Necessidade de Compras', 'Cálculo da Necessidade de Compras');
        calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        //calculoNecessidadeCompras.selecionaPeriodo();
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');
        expect(element(by.css('#PEACRESCIMO')).getAttribute('disabled')).toBe('true');                                                                                                                                                                
    });

    it('Deve utilizar o parâmetro Considerar Estoque no Cálculo da Necessidade de Compras', function () {
        calculoNecessidadeCompras.abrir('Parâmetros de Compras e Suprimentos', 'Parâmetros de Compras e Suprimentos');
        calculoNecessidadeCompras.navegar('Unidade');
        calculoNecessidadeCompras.parametroUnidadeDiversos('DEPOSITO BC 129');
        calculoNecessidadeCompras.parametroEstoque();
        z.component.footer.clickRightActionByLabel('Salvar');
        calculoNecessidadeCompras.abrir('Cálculo da Necessidade de Compras', 'Cálculo da Necessidade de Compras');
        calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        //calculoNecessidadeCompras.selecionaPeriodo();
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');
        expect(calculoNecessidadeCompras.textoEstoque()).toBe('Considera Estoque');
    });

    it('Deve desabilitar o parâmetro Considerar Estoque no Cálculo da Necessidade de Compras', function () {
        calculoNecessidadeCompras.abrir('Parâmetros de Compras e Suprimentos', 'Parâmetros de Compras e Suprimentos');
        calculoNecessidadeCompras.navegar('Unidade');
        calculoNecessidadeCompras.parametroUnidadeDiversos('DEPOSITO BC 129');
        calculoNecessidadeCompras.parametroEstoqueDesabilitado();
        z.component.footer.clickRightActionByLabel('Salvar');
        calculoNecessidadeCompras.abrir('Cálculo da Necessidade de Compras', 'Cálculo da Necessidade de Compras');
        calculoNecessidadeCompras.selecionaUnidade('DEPOSITO BC 129');
        //calculoNecessidadeCompras.selecionaPeriodo();
        calculoNecessidadeCompras.selecionaProduto('MATERIA PRIMA', 'MATERIA PRIMA');
        expect(calculoNecessidadeCompras.textoEstoqueDesabilitado()).toBe('Não Considera Estoque');
    }); 

});